"""

  Usability application category class
  Copyright 2005 Mikko Ohtamaa

  See class comments for more details

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as described
  in licence.txt

"""
# Zope imports
from AccessControl import getSecurityManager, ClassSecurityInfo, Unauthorized
from AccessControl.PermissionRole import rolesForPermissionOn

# Plone imports
from Products.ATContentTypes.content.base import ATCTOrderedFolder, ATCTFolder
from Products.ATContentTypes.content.folder import ATFolderSchema, ATFolder
from Products.CMFCore.permissions import ModifyPortalContent, DeleteObjects, ListFolderContents, View
from Products.CMFCore.utils import getToolByName
from Products.Usability.helpers import addPermissionsForRole, doNotAcquirePermissions

from Permissions import *

from Products.Archetypes.public import \
    StringField, \
    TextAreaWidget, \
    BooleanField, \
    BooleanWidget, \
    BaseContent, \
    BaseSchema, \
    BaseFolder, \
    Schema, \
    registerType
    

schema = ATFolderSchema.copy() + Schema(
    (    
        StringField('description',                  
                  widget=TextAreaWidget(
                      description="What kind of applications come to this category",
                      ),
                  ),            
    )
)

# Set all read/write permissions once
for field in schema.fields():
    field.read_permission = VIEW_USABILITY_ITEMS_PERMISSION
    field.write_permission = MANAGE_USABILITY_ITEMS_PERMISSION


class ApplicationCategory(ATFolder):
    """
    Abstract base for ApplicationSuperCategory and ApplicationSubCategory
    """
    schema = schema
    
    filter_content_types = True
        
    # Generate user friendly id from title during creation
    _at_rename_from_title = True
    
    content_icon   = 'folder_icon.gif'
                
    #security = ClassSecurityInfo()                
 
    def displayContentsTab(self):
        """ Display Contents tab only for managers 
        
        Reduce information flow for clueless users
        
        Seems that for contents tab all permissions checks are ignored.
        I couldn't get contents hidden by settings Listing denided
        or by modifying folderListing action. It is specially handled.
        """
        return getSecurityManager().checkPermission(MANAGE_USABILITY_ITEMS_PERMISSION, self)
                
    #security.declareProtected(ADD_ISSUES_PERMISSION, 'invokeFactory')
    #def invokeFactory(self, type_name, id, RESPONSE=None, *args, **kw):
    #    """ Tune permissions for creating new items
    #    
    #    Editors can create Applications. With MANAGE_USABILITY_ITEMS_PERMISSION
    #    one can modify Application folder structure, by adding more Application Folders
    #    
    #    TODO: Checks permission in global context, how to check it in local context
    #    """     
    #    
    #    #print "Creating:" + type_name
    #      
    #    if(type_name == "ApplicationCategory"):        
    #        if not getSecurityManager().checkPermission(MANAGE_USABILITY_ITEMS_PERMISSION, self):
    #            raise Unauthorized, "User " + str(getSecurityManager().getUser()) + " doesn't have permission to create Application Folders, missing permission:" + MANAGE_USABILITY_ITEMS_PERMISSION
    #    elif(type_name == "Application"):        
    #        if not getSecurityManager().checkPermission(ADD_ISSUES_PERMISSION, self):
    #            raise Unauthorized, "User " + str(getSecurityManager().getUser()) + " doesn't have permission to create Application, missing permission:" + EDIT_USABILITY_ITEMS_PERMISSION
        
        # lot of debugs...
        #print "User:" + str(getSecurityManager().getUser())
        #print "Roles:" + str(getSecurityManager().getUser().getRoles())
        #print "SecurityManager:" + str(getSecurityManager().__class__)
        #print "SecurityManager.policy:" + str(getSecurityManager()._policy)
        #print "SecurityManager.context:" + str(getSecurityManager()._context)
        #print "SecurityManager.context.user:" + str(getSecurityManager()._context.user)
        #print "SecurityManager.context.user:" + str(getSecurityManager()._context.user.__class__)   
                    
        #return ATFolder.invokeFactory(self, type_name, id, RESPONSE, *args, **kw)
        
               
# Abstract class
# registerType(ApplicationCategory)