# Zope imports
from AccessControl import getSecurityManager, ClassSecurityInfo, Unauthorized

# Plone imports
from Products.Archetypes.public import \
    registerType

# Local imports
from ApplicationCategory import ApplicationCategory
from Permissions import *

class ApplicationSuperCategory(ApplicationCategory):
    """ Category containing other categories """
    
    typeDescription= 'Application category containing other categories'
    meta_type      = 'ApplicationSuperCategory'
    archetype_name = 'App. category for categories'
    content_icon   = 'folder_icon.gif'
    _at_rename_from_title = True
    
    filter_content_types = True
    allowed_content_types = [ "ApplicationSuperCategory", "ApplicationSubCategory" ]
        
    security = ClassSecurityInfo()    
    security.declareProtected(MANAGE_USABILITY_ITEMS_PERMISSION, 'invokeFactory')


def modify_fti(fti):
    """ Modifies factory type information for Application type
    
    - Use custom permissions    
    """
    
    #print "modify_fti:" + str(fti)
    
    for action in fti.get("actions", ()):
        if action["id"]=="view":
            action["permissions"] = (VIEW_USABILITY_ITEMS_PERMISSION,)
        elif action["id"]=="edit":
            action["permissions"] = (MANAGE_USABILITY_ITEMS_PERMISSION,)

registerType(ApplicationSuperCategory)
    
    
    
    
    