"""

  Usability application category class
  Copyright 2005 Mikko Ohtamaa

  Usability product constant variables

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as described
  in licence.txt

"""
from Products.CMFCore.CMFCorePermissions import AddPortalContent
from Products.CMFCore.CMFCorePermissions import setDefaultRoles
from Products.Archetypes.public import DisplayList
from Permissions import * 

PROJECTNAME = "Usability"
SKINS_DIR = "skins"

GLOBALS = globals()

USABILITY_MANAGER_ROLE="Usability Manager"
USABILITY_EDITOR_ROLE="Usability Editor"
USABILITY_VIEWER_ROLE="Usability Viewer"

# ATVocabularyManager vocabulary id for possible issue features
FEATURE_VOCABULARY="issue_features"

ISSUE_LEVELS = DisplayList( ( 
    ( 'cosmetic', 'Cosmetic' ), 
    ( 'annoying', 'Annoying' ), 
    ( 'frustrating', 'Frustrating' ), 
    ( 'fatal', 'Fatal' ), 
    ) )

#ISSUE_LEVELS = [ "Cosmetic", "Annoying", "Frustrating", "Fatal" ]
    
ISSUE_FEATURES = ( 
    "Design choice", 
    "Misleading name", 
    "Item is hard to find" )

ISSUE_STATUSES = DisplayList( ( 
    ( 'reported', 'Reported to linux-usability.com' ), 
    ( 'notified', 'Author has been notified' ), 
    ( 'closed', 'Issue has been solved' ), 
    ) )


# All other roles are managed locally by Archetype items themselves,
# because global permissions override local permission thus invalidating
# role manegement by workflow
setDefaultRoles( MANAGE_USABILITY_ITEMS_PERMISSION, ( 'Manager', USABILITY_MANAGER_ROLE, ) )
setDefaultRoles( EDIT_USABILITY_ITEMS_PERMISSION, ( 'Manager', USABILITY_MANAGER_ROLE, ) )
setDefaultRoles( ADD_ISSUES_PERMISSION, ( 'Manager', USABILITY_MANAGER_ROLE, ) )
setDefaultRoles( VIEW_USABILITY_ITEMS_PERMISSION, ( 'Anonymous', 'Manager', 'Member' ) )

